<template>
  <div class="component-container">
    <lenna-modal ref="lennaModal"></lenna-modal>
    <!-- <lenna-loading v-show="isLoading"></lenna-loading> -->
    <div>
      <!-- <h5 class="text-primary">Connect to</h5> -->
      <h3 class="text-primary">Integrate with LINE Messenger</h3>
      <hr>
      <form @submit.prevent="submitForm">
        <div class="form-group">
          <span
            class="text-muted"
          >Fill in the required credentials below, you can get it from your LINE Developer Platform .</span>
        </div>

        <div class="form-group row">
          <strong class="col-sm-12 col-form-label">Access Token</strong>
          <div class="col-sm-10">
            <textarea
              name="access token"
              v-validate="'required'"
              class="form-control"
              v-model="form.accessToken"
              placeholder="Access Token"
              rows="2"
              spellcheck="false"
            ></textarea>
            <span class="text-danger">{{ errors.first('access token') }}</span>
          </div>
        </div>

        <br>
        <div class="form-group">
          <span
            class="text-muted"
          >Copy this webhook URL and paste it on your LINE Developer Platform</span>
        </div>

        <div class="form-group row">
          <strong class="col-sm-12 col-form-label">Webhook URL</strong>
          <div class="col-sm-10">
            <input
              type="text"
              class="form-control"
              id="webhook-url"
              v-model="this.webhookUrl"
              placeholder="Webhook URL"
              readonly
            >
          </div>
          <div class="col-sm-2">
            <button class="btn h-100 btn-rounded btn-primary" @click.prevent="handleCopy">Copy</button>
          </div>
        </div>
        <br>
        <div class="form-group row">
          <input type="hidden" v-model="form.status">
          <div class="col-sm-6">
            <button
              type="button"
              class="btn btn-rounded btn-block"
              :class="(!form.status) ? 'btn-secondary': 'btn-danger'"
              :disabled="!form.status"
              @click="disconnectChannel"
            >Disconnect</button>
          </div>
          <div class="col-sm-6">
            <button
              type="submit"
              class="btn btn-rounded btn-block btn-primary"
            >{{(form.status) ? 'Update': 'Connect'}}</button>
          </div>
        </div>
      </form>
    </div>
  </div>
</template>
<script>
import EventBus from "@/EventBus.js";
export default {
  data() {
    return {
      form: {
        accessToken: "",
        // secretKey:'',
        status: false,
        channelName: "line"
      }
    };
  },
  computed: {
    webhookUrl() {
      return (
        this.baseUrl +
        "/api/" +
        this.$store.getters.appId.hashed +
        "/webhook/line"
      );
    }
  },
  methods: {
    handleCopy() {
      let copyCode = document.querySelector("#webhook-url");
      copyCode.setAttribute("type", "text");
      copyCode.select();
      document.execCommand("copy");
    },
    async disconnectChannel() {
      try {
        let data = {
          channelName: this.form.channelName,
          status: false
        };
        let response = await this.$axios.put(
          `api/${this.$store.getters.appId.hashed}/integrate/update`,
          data
        );
        response = response.data;

        this.$refs.lennaModal.show("info", "Success", response.message);

        this.form.status = false;
        EventBus.$emit("toggleStatusMain", "line");
      } catch (error) {
        this.form.status = !this.form.status;
        this.$refs.lennaModal.show(
          "alert",
          "Sorry",
          error.response.data.message
        );
      }
    },
    async submitForm() {
      let validated = await this.$validator.validateAll();

      if (validated) {
        try {
          let formData = {
            ...this.form,
            status: true,
            webhookUrl: this.webhookUrl
          };
          let response = await this.$axios.post(
            `api/${this.$store.getters.appId.hashed}/integrate`,
            formData
          );
          this.form.status = true;

          this.$refs.lennaModal.show("info", "Success", response.data.message);

          EventBus.$emit("toggleStatusMain", "line");
        } catch (error) {
          this.$refs.lennaModal.show("alert", "Error", "Something wrong!");
        }
      } else {
        this.$refs.lennaModal.show(
          "alert",
          "Sorry",
          "You must correct your form first"
        );
      }
    },
    async fetchData() {
      let response = await this.$axios.get(
        `api/${this.$store.getters.appId.hashed}/integrate`
      );
      response = response.data;
      let channelData = response.data.find(function(item) {
        return item.name == "line";
      }).integration;

      if (channelData != null) {
        this.form.accessToken = channelData.integration_data.accessToken;
        // this.form.secretKey = channelData.integration_data.secretKey
        this.form.status = channelData.status;
      }
    }
  },
  mounted() {
    this.fetchData();

    EventBus.$on("toggleStatus", value => {
      this.fetchData();
    });
  }
};
</script>
<style lang="scss">
.component-container {
  position: relative;
}
</style>
